/*
 * graphics.c - Ver.03
 */

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

/*
 *
 */

#include	"graphics.h"

/*
 *	Q[ʂ͍_ W_W_SIZE*W_W_SIZE ̋`̍Wnōl
 */

#define	SCALE		200

#define	W_W_SIZE	(2*SCALE)	/* Window ̉ (200) */
#define	W_H_SIZE	(2*SCALE)	/* Window ̏c (200) */

/*
 *	Q[̍W (0,0)-(X,Y) AOpenGL ̍W (-1,-1)-(1,1) ւ̕ϊ
 */

#define	rSize(R)	((double)(R)/SCALE)	/* TCY̕ϊ */
#define	xPos(X)		rSize(X-SCALE)		/* _炷 */
#define	yPos(Y)		rSize(Y-SCALE)

/*
 *	ubN̏
 */

#define	B_W_COUNT	10		/* ubN̉̌ */
#define	B_H_COUNT	5		/* ubNš */

#define	B_W_SIZE	( W_W_SIZE   /B_W_COUNT)	/* ubN̉ */
#define	B_H_SIZE	((W_H_SIZE/4)/B_H_COUNT)	/* ubNs */

#define	B_W_PITCH	(B_W_SIZE/10)				/* ubN̉̌ */
#define	B_H_PITCH	(B_H_SIZE/10)				/* ubNš */

#define	B_W_BASE	0
#define	B_H_BASE	(W_H_SIZE*3/4)				/* ubN̔zu͏ 1/4 */

#define	bxPos(BX)		(B_W_BASE+B_W_SIZE/2+(BX)*B_W_SIZE)
#define	byPos(BY)		(B_H_BASE+B_H_SIZE/2+(BY)*B_H_SIZE)

#define	BLOCK_ON	1
#define	BLOCK_OFF	0

static char block[B_W_COUNT][B_H_COUNT];	/* ubN̏ */
/* block[x][y] ... (x,y) ̏ɂubÑf */

/*
 *	ph̏
 */

#define	PADDLE_W_SIZE	B_W_SIZE
#define	PADDLE_H_SIZE	B_H_SIZE

#define	PADDLE_DX	(B_W_SIZE/10)

static int paddleSpeed = PADDLE_DX;				/* pḧړx */
static int paddleLength = PADDLE_W_SIZE;		/* ph̒ */
static int paddleX = W_W_SIZE/2;				/* ph X W */

/*
 *	Q[WŁAhׂ̋`
 */

static	void	fillRect( int x1, int y1, int x2, int y2 ) {
  double	gx1 = xPos(x1);	/* Q[W OpenGL .. */
  double	gy1 = yPos(y1);
  double	gx2 = xPos(x2);
  double	gy2 = yPos(y2);

  glBegin(GL_QUADS);		/* OpenGL ̖߂ŋ`Jn */
  glVertex2d(gx1,gy1);		/* ̓_̍W */
  glVertex2d(gx1,gy2);		/* E̓_̍W */
  glVertex2d(gx2,gy2);		/* E̓_̍W */
  glVertex2d(gx2,gy1);		/* ̓_̍W */
  glEnd();
}

/*
 *	w肵ꏊ𒆐SƂubN\
 */

static void drawBlock( int px, int py, int bw, int bh ) {

  fillRect (
			px - (bw-B_W_PITCH)/2,
			py - (bh-B_H_PITCH)/2,
			px + (bw-B_W_PITCH)/2,
			py + (bh-B_H_PITCH)/2 );
}

static void display(void)
{
  int bx;
  int by;

  glClearColor(0.0, 0.4, 0.0, 0.0);	/*  */
  glClear(GL_COLOR_BUFFER_BIT);		/* EBhE̒hׂ */

  /* eXgR[h */

  glColor3f(1.0, 1.0, 1.0); /* `敨̂ɔFݒ */

  /* ubN̕\ */
  for ( by = 0; by < B_H_COUNT; by++ ) {
	for ( bx = 0; bx < B_W_COUNT; bx++ ) {
	  if ( block[bx][by] == BLOCK_ON ) {
		drawBlock ( bxPos(bx), byPos(by), B_W_SIZE, B_H_SIZE );
	  }
	}
  }

  /* ph̕\ */
  drawBlock ( paddleX, PADDLE_H_SIZE / 2, paddleLength, PADDLE_H_SIZE );

  glFlush();  /* \̏I */
}

/*
 *	s
 */

/*
 *	ubN̐ݒu
 */

static void blockInit() {
  int bx;
  int by;

  /* ׂẴubNɑ΂ */

  for ( by = 0; by < B_H_COUNT; by++ ) {
	for ( bx = 0; bx < B_W_COUNT; bx++ ) {
	  block[bx][by] = BLOCK_ON;	/* ubN On ɂ */
	}
  }

}

static void init(void)
{
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glShadeModel(GL_FLAT);

	blockInit();
}


/*
 *	phw肵ʒuɈړB
 *	Aړ悪ÄȌꍇ́ÄɂȂ悤ɒĈړB
 */

static	void	move_paddle ( int x ) {

  if ( x <= paddleLength/2 ) {					/* ߂ */
	x = paddleLength/2+1;							/* 肬ɂ */
  } else if ( x >= W_W_SIZE - paddleLength/2 ) {	/* E߂ */
	x = W_W_SIZE - paddleLength/2 - 1;			/* E肬ɂ */
  }

  paddleX = x;					/* phړ */
}

/*
 *	{^ƌĂ΂֐
 */

static void mouse(int button, int state, int x, int y)
{

	switch (button) {
	case GLUT_LEFT_BUTTON:				/* {^ꂽ */
	  if ( state == GLUT_DOWN ) {		/* vbV */
		move_paddle ( x );				/* }EẌʒuɃphړ */
		display();						/* \̍XV */
	  }
	  break;
	case GLUT_MIDDLE_BUTTON:
	  break;
	case GLUT_RIGHT_BUTTON:
	  break;
	default:
	  break;
	}
}

/*
 *	̑̏ꍇɁAPIɉxĂяo
 */

static	void	idle(void) {
}

/*
 *	L[{[h̃L[ƌĂ΂֐
 * 	L[{[hɉ΁AύX
 */

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':  /* '\033'  ESC  ASCII R[h */
    exit(0);
	/* L[{[h 'q'/'Q'/ESC L[ƏI */
  case ',':
	/* ph ( Ɉړ ) */
	if ( paddleX > paddleLength/2 + paddleSpeed ) {	/* ړ\Ȃ.. */
	  paddleX = paddleX - paddleSpeed;				/* ̕Ɉړ */
	  display();
	}
    break;

  case '.':
	/* ph ( EɈړ ) */
	if ( paddleX < W_W_SIZE - paddleLength/2 - paddleSpeed ) {
	  paddleX = paddleX + paddleSpeed;
	  display();
	}
    break;

 case '+':
	/* ph̒𒷂 */
	if ( paddleLength < W_W_SIZE ) {
	  paddleLength = paddleLength + 10;
	  move_paddle ( paddleX );
	  display();
	}
    break;



  default:
    break;
  }
}

/*
 *	GL ̏֐
 */

void graphics_init ( int argc, char** argv )
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA);
//	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize(W_W_SIZE,W_H_SIZE);
	/* Window ̃TCY */
	glutInitWindowPosition(100, 100);
	glutCreateWindow(argv[0]);
	init();

	glutDisplayFunc(display);
	/* ŁAKvɉāAʂ̂Ȃ
	   s֐ (display) w肵Ă */
	glutMouseFunc(mouse);
	/* ŁA}EXNbNꂽ̏
	   s֐(mouse)w肵Ă */
	glutKeyboardFunc(keyboard);
	/* ŁAL[{[hꂽ̏
	   s֐(keyboard)w肵Ă */
	glutIdleFunc(idle);
	/* ŁA͂ĂȂ̏
	   s֐(idle)w肵Ă
	   Aj[VȂǎIɁAԂ
	   XV鏈 idle ɂ点
	*/

	glutMainLoop();
	/* `Jn */
}

/*
 *
 */

